%define apache_version 1.3.33
%define modssl_version 2.8.22

Summary:     A high performance Unix-based HTTP server
Name:        apache
Version:     %{apache_version}
Release:     24.pp
License:     GPL
Group:       System Environment/Daemons
Source0:     http://httpd.%{name}.org/dist/httpd/%{name}_%{version}.tar.gz
Source1:     http://www.modssl.org/source/mod_ssl-%{modssl_version}-%{version}.tar.gz
Source2:     %{name}.init
Source3:     apachectl.sh
Source4:     httpd.conf
Source5:     vhosts.conf
Source6:     modules.conf
Source7:     mime.types
Patch0:      %{name}-apxs.patch
Patch1:      %{name}-frontpage5.patch
Patch2:      %{name}_1.3.22-ReadRequestTimeout-directive.patch
Patch3:      %{name}-proxy-http10.patch.gz
Patch4:      force_language_priority.patch
URL:         http://www.%{name}.org/
Buildroot:   /var/tmp/%{name}-root
Vendor:      Apache Software Foundation
Packager:    Peter Pramberger <peter.pramberger@member.fsf.org>
Requires:    glibc mm gdbm db4 >= 4.2 expat perl
Provides:    %{name}.pp webserver web-server
Prereq:      /bin/bash /usr/sbin/groupadd /usr/sbin/useradd
BuildPrereq: gcc >= 2.96 /usr/bin/perl /bin/mkdir /usr/bin/make
BuildPrereq: /usr/bin/install /usr/bin/find /bin/mv /bin/ln
BuildPrereq: /bin/sed mm-devel gdbm-devel db4-devel >= 4.2
BuildPrereq: glibc-devel expat-devel
ExclusiveOS: linux

%description
Apache is a powerful, full-featured, efficient and freely-available
Web server. Apache is also the most popular Web server on the
Internet.


%package devel
Group:       Development/Libraries
Summary:     Development tools for the Apache Web server.
Requires:    %{name} = %{version}-%{release}
Provides:    %{name}-devel.pp

%package manual
Group:       Documentation
Summary:     Documentation for the Apache Web server.
Requires:    %{name} = %{version}-%{release}
Provides:    %{name}-manual.pp


%description devel
The %{name}-devel package contains the APXS binary and other files that
you'll need to build Dynamic Shared Objects (DSOs) for Apache.

If you are installing the Apache Web server, and you want to be 
able to compile or develop additional modules for Apache, you'll 
need to install this package.

%description manual
The %{name}-manual package contains the complete manual and reference
guide for the Apache Web server.  If you need Apache documentation
installed on the local machine, install this package.  The information
can also be found on the Web at http://www.%{name}.org/docs/.


%prep
%setup -q -n %{name}_%{version} -a1
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
cd src/modules/standard
%patch4 -p0
cd ../../..
cp -f %{SOURCE7} .


%build
cd mod_ssl*
   export CFLAGS="$RPM_OPT_FLAGS"
   export EAPI_MM="SYSTEM"
   ./configure --with-apache=.. --with-eapi-only
cd ..
export OPTIM="$RPM_OPT_FLAGS"
export LIBS="-lgdbm -lpthread"
export INCLUDES="-I/usr/include/gdbm"
export CFLAGS="$CFLAGS -DDYNAMIC_MODULE_LIMIT=256 -DHARD_SERVER_LIMIT=2048 -DDEFAULT_LISTENBACKLOG=2047"
./configure \
	--prefix=/etc/httpd              \
	--exec-prefix=/usr               \
	--sysconfdir=/etc/httpd/conf     \
	--localstatedir=/var             \
	--libexecdir=/usr/lib/apache     \
	--enable-rule=EAPI               \
	--mandir=/usr/share/man          \
	--logfiledir=/var/log/httpd      \
	--sbindir=/usr/sbin              \
	--datadir=/var/httpd             \
	--runtimedir=/var/run            \
	--includedir=/usr/include/apache \
	--proxycachedir=/var/httpd/cache \
	--enable-module=all              \
	--enable-shared=max              \
	--with-perl=/usr/bin/perl        \
	--enable-suexec                  \
	--suexec-caller=www              \
	--suexec-uidmin=101              \
	--suexec-gidmin=100              \
	--server-uid=www                 \
	--server-gid=www
for file in `find . -type f -exec fgrep -l /bin/perl {} \;`; do
    cat $file | \
    sed -e 's+/usr/local/bin/perl5+/usr/bin/perl+g' \
        -e 's+/usr/local/bin/perl+/usr/bin/perl+g' > tmp_file;
    mv tmp_file $file;
done
make all


%define __os_install_post /usr/lib/rpm/brp-compress


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/etc/httpd/private
mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf/modules
make install root=$RPM_BUILD_ROOT
ln -s /var/log/httpd $RPM_BUILD_ROOT/etc/httpd/logs
ln -s /usr/lib/apache $RPM_BUILD_ROOT/etc/httpd/modules
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT/etc/rc.d/init.d/httpd
install -m 755 %{SOURCE3} $RPM_BUILD_ROOT/usr/sbin/apachectl
rm -f $RPM_BUILD_ROOT/etc/httpd/conf/mime*
rm -f $RPM_BUILD_ROOT/var/httpd/cgi-bin/*
ln -s /etc/mime.types $RPM_BUILD_ROOT/etc/httpd/conf/mime.types
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT/etc/httpd/conf
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT/etc/httpd/conf/httpd.conf.default
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT/etc/httpd/conf
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT/etc/httpd/conf/vhosts.conf.default
install -m 644 %{SOURCE6} $RPM_BUILD_ROOT/etc/httpd/conf/modules
install -m 644 %{SOURCE6} $RPM_BUILD_ROOT/etc/httpd/conf/modules/modules.conf.default


%pre
if ! grep "^www" /etc/group > /dev/null 2>&1; then
   /usr/sbin/groupadd www > /dev/null 2>&1
fi
if ! grep "^www" /etc/passwd > /dev/null 2>&1; then
   /usr/sbin/useradd -g www -G www -d /var/httpd \
      -r -s /dev/null www > /dev/null 2>&1
fi


%post
# safely add .htm to mime types if it is not already there
if [ -f /etc/mime.types ]; then
   TEMPTYPES=`/bin/mktemp /tmp/mimetypes.XXXXXX`
   [ -z "$TEMPTYPES" ] && {
      echo "Warning: could not make temporary file, htm not added to /etc/mime.types" >&2
      exit 0
   }
   ( grep -v "^text/html"  /etc/mime.types
      types=`grep "^text/html" /etc/mime.types | cut -f2-`
      echo -en "text/html\t\t\t"
      for val in $types ; do
         if [ "$val" = "htm" ] ; then
            continue
         fi
         echo -n "$val "
      done
      echo "htm"
   ) > $TEMPTYPES
   cat $TEMPTYPES > /etc/mime.types && /bin/rm -f $TEMPTYPES
else
   cp -f %{_defaultdocdir}/%{name}-%{version}/mime.types /etc > /dev/null 2>&1
fi
/sbin/chkconfig --add httpd
if [ -f /var/lock/subsys/httpd ]; then
   /etc/rc.d/init.d/httpd restart
fi


%preun
if [ $1 = 0 ] ; then
   /sbin/chkconfig httpd off
   /sbin/chkconfig --del httpd
   if [ -f /var/lock/subsys/httpd ]; then
      /etc/rc.d/init.d/httpd stop
   fi
fi


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root)
%doc ABOUT* Announcement* INSTALL LICENSE NOTICE README* WARNING* mime.types
/etc/rc.d/init.d/httpd
%dir /etc/httpd
%dir /etc/httpd/conf
%dir /etc/httpd/conf/modules
%config(noreplace) /etc/httpd/conf/*conf
%config(noreplace) /etc/httpd/conf/magic
/etc/httpd/conf/*.default
%config /etc/httpd/conf/mime.types
/etc/httpd/logs
/etc/httpd/modules
%config(noreplace) /etc/httpd/conf/modules/*.conf
/etc/httpd/conf/modules/*.default
%dir /etc/httpd/private
/usr/bin/*
/usr/sbin/httpd
/usr/sbin/ab
%config(noreplace) /usr/sbin/apachectl
/usr/sbin/logresolve
/usr/sbin/rotatelogs
/usr/sbin/suexec
%dir /usr/lib/apache
/usr/lib/apache/*
/usr/share/man/man1/*
/usr/share/man/man8/httpd*
/usr/share/man/man8/ab*
/usr/share/man/man8/logresolve*
/usr/share/man/man8/rotatelogs*
/usr/share/man/man8/suexec*
/usr/share/man/man8/apachectl*
%dir /var/httpd
%dir /var/httpd/htdocs
%dir /var/httpd/icons
/var/httpd/icons/*
%dir /var/httpd/cgi-bin
%dir %attr(750,www,www) /var/httpd/cache
%dir /var/log/httpd

%files devel
%defattr(-,root,root)
%dir /usr/include/apache
/usr/include/apache/*
/usr/sbin/apxs
/usr/share/man/man8/apxs*

%files manual
%defattr(-,root,root)
/var/httpd/htdocs/*


%changelog
* Fri Oct 29 2004 peter.pramberger@member.fsf.org
- new version 1.3.33

* Fri May 14 2004 peter.pramberger@member.fsf.org
- new version 1.3.31
- build against Berkeley DB 4.2

* Sun Nov 02 2003 peter.pramberger@member.fsf.org
- new version 1.3.29

* Fri Oct 03 2003 peter.pramberger@member.fsf.org
- man pages moved to /usr/share/man
- minor bug fixes in spec file
- increased HARD_SERVER_LIMIT to 2048

* Fri Aug 22 2003 peter.pramberger@member.fsf.org
- new version 1.3.28
- fixed ReadTimeout patch to fit into 1.3.28

* Wed May 07 2003 peter.pramberger@member.fsf.org
- compiled for RH73
- now using system expat

* Tue Nov 05 2002 peter.pramberger@member.fsf.org
- added proxy module from apache 1.3.22 (only HTTP/1.0)
  named libproxy_http10.so
- new version 1.3.27

* Mon Aug 19 2002 peter.pramberger@member.fsf.org
- fixed error in linking against libexpat

* Thu Aug 01 2002 peter.pramberger@member.fsf.org
- new version 1.3.26

* Sat Nov 10 2001 peter.pramberger@member.fsf.org
- new version 1.3.22
- changed user from apache to www
- minor bugfixes

* Tue Oct 23 2001 peter.pramberger@member.fsf.org
- added frontpage patch

* Thu Oct 11 2001 peter.pramberger@member.fsf.org
- added %doc

* Sun Oct 07 2001 peter.pramberger@member.fsf.org
- created

